<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques des actions entreprises n'ont pas pu être chargées."
    />
    <template v-else-if="interviewsActionsEntreprises">
      <h2 class="fr-h5">Actions entreprises</h2>
      <StatsList
        :total-count="totalCount"
        :stats="interviewsActionsEntreprises"
      />
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { INTERVIEW_COLOR } from '~~/utils/constants/interview'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    totalCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: interviewsActionsEntreprises,
    pending,
    error
  } = useLazyAsyncData(
    'interviewsActionsEntreprises',
    loadInterviewsActionsEntreprises,
    {
      server: false
    }
  )

  async function loadInterviewsActionsEntreprises() {
    const res = await $getItems('follow_ups', {
      fields: ['redirected', 'help_request'],
      filter: {
        ...props.filters,
        _or: [{ redirected: { _eq: true } }, { help_request: { _eq: true } }]
      }
    })

    if (res.status === 200) {
      const _interviewsActionsEntreprises = {
        redirected: {
          key: 'redirected',
          label: 'Réorientation',
          color: INTERVIEW_COLOR,
          count: 0
        },
        help_request: {
          key: 'help_request',
          label: 'Instruction',
          color: INTERVIEW_COLOR,
          count: 0
        }
      }

      res.data.data.forEach(interview => {
        if (interview.redirected) {
          _interviewsActionsEntreprises.redirected.count++
        }
        if (interview.help_request) {
          _interviewsActionsEntreprises.help_request.count++
        }
      })

      const interviewsActionsEntreprisesValues = Object.values(
        _interviewsActionsEntreprises
      )
      interviewsActionsEntreprisesValues.sort((a, b) => b.count - a.count)
      return interviewsActionsEntreprisesValues
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
